# Easy Install node.js
| Sponsored by [Daplie](https://daplie.com) |

Automated node.js installers for OS X and Ubuntu

**node.js only** (no dev tools)

```bash
# install node.js without development dependencies
curl -fsSL bit.ly/install-min-node | bash

# using wget instead of curl (Ubuntu)
wget -nv bit.ly/install-min-node -O - | bash
```

**node.js + dev tools**

Install node.js and basic development tools - git, node, gcc, pkg-config, etc

```bash
curl -L bit.ly/install-dev-node -o ./node-dev; bash ./node-dev
```

<!-- bit.ly/easy-install-node -->

## Screencast

[How to Setup a VPS for node.js Development](https://www.youtube.com/watch?v=ypjzi1axH2A) - [(3:06 installing node.js](https://www.youtube.com/watch?v=ypjzi1axH2A#t=186))

## Choosing a specific version

```bash
echo "Current node.js version is $(curl -fsSL https://nodejs.org/dist/index.tab | head -2 | tail -1 | cut -f 1)"
```

```bash
# To install a specific version rather than defaulting to latest
# latest version at time of writing are v4.4.1 and v5.9.1
echo "v7.9.0" > /tmp/NODEJS_VER
```

## Notes

* [OS X](#apple-os-x)
* [Ubuntu Linux](#ubuntu-linux)
* [Important Notes](#other-things-you-should-know)

### Apple OS X

First you need to **Install XCode Command Line Tools**

```bash
xcode-select --install
```

Then you need to **Accept the XCode License** by running any command installed by Xcode with sudo. We'll use git.

```bash
sudo git --version
```

You can scroll to the bottom by hitting shift+G (capital G).

Type `agree` and hit enter to accept the license.

Now you can install node.js

```bash
curl -fsSL bit.ly/install-dev-node -o /tmp/node-dev.sh; bash /tmp/node-dev.sh
```

*TODO*: Make it easier to accepting the license (automatic?)

### Ubuntu Linux

```bash
wget -nv bit.ly/install-dev-node -O /tmp/node-dev.sh; bash /tmp/node-dev.sh
```

### Other things you should know

This is what gets installed:

* rsync
* curl
* wget
* git
* xcode / brew / build-essential / pkg-config / gcc
* node (including npm)
* jshint

**NOTE**: If you're running a node.js server on an edge server,
I'd highly recommend that you also install `fail2ban` to secure ssh -
especially if you haven't switched your server to use key-only authentication.
